## jvoisin-snuffleupagus.zip

=== Makefile ===
.DEFAULT_GOAL=help
.PHONY=help
SHELL = /bin/bash

SRC := src

clean:  ## clean everything
	make -C $(SRC) clean
	cd $(SRC); phpize --clean

release:  ## compile with releases flags
	cd $(SRC); phpize
	cd $(SRC); ./configure --enable-snuffleupagus
	make -C $(SRC)
	strip $(SRC)/.libs/snuffleupagus.so

install: release  ## compile and install snuffleupagus
	make -C $(SRC) install

compile_debug:  ## compile a debug build
	cd $(SRC); if [[ ! -f configure ]]; then phpize; fi; \
	./configure --enable-snuffleupagus --enable-debug --enable-debug-stderr && \
	make clean ; make -j4

DOCKER_IMAGE := php:latest
docker: ## start docker container with current PHP
	@echo "Starting new docker container with snuffleupagus bind-mounted to /sp"
	docker run -it -v "$$(pwd)":/sp $(DOCKER_IMAGE) /bin/bash

linked-clone:
	@if [[ "$(CLONE)" == "" ]]; then echo -e "==> Please provide clone name, e.g.\n  make linked-clone CLONE=php8.1\n"; exit 1; fi
	@if [[ -d "src-$(CLONE)" ]]; then echo -e "==> Clone '$(CLONE)' already exists.\n"; exit 1; fi
	@echo "==> CREATING LINKED CLONE IN 'src-$(CLONE)' <=="
	mkdir "src-$(CLONE)"; cd "src-$(CLONE)"; \
	SRCDIR=../src; ln -s $$SRCDIR/*.[hc] $$SRCDIR/config.m4 $$SRCDIR/snuffleupagus.php $$SRCDIR/Makefile.frag $$SRCDIR/*.re .; \
	cp -r $$SRCDIR/tests .
	@echo -e "==> DONE. <==\nCompile a debug build with\n  make compile_debug SRC=src-$(CLONE)"

tests: release tests-incremental  ## compile a release build and run the testsuite

tests-incremental:  ## perform an incremental build and run the testsuite
	make -C $(SRC)
	TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 SP_SKIP_OLD_PHP_CHECK=1 make -C $(SRC) test

coverage:  ## compile snuffleugpaus, and run the testsuite with coverage
	cd $(SRC); phpize
ifeq ($(CC),clang)
	cd $(SRC); CFLAGS="-fprofile-instr-generate -fcoverage-mapping" ./configure --enable-snuffleupagus
	make -C $(SRC)
	sed -i "s/\$$ext_params -d display_errors=0 -r/-d display_errors=0 -r/" $(SRC)/run-tests.php
	LLVM_PROFILE_FILE="sp_%p_%m.profraw" TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C $(SRC) test
	llvm-profdata-4.0 merge ./$(SRC)/*.profraw -o ./$(SRC)/sp.profdata
	llvm-cov report -instr-profile=./$(SRC)/sp.profdata ./$(SRC)/modules/snuffleupagus.so
else
	cd $(SRC); ./configure --enable-snuffleupagus --enable-coverage
	make -C $(SRC)
	rm -Rf $(SRC)/COV.html
	sed -i "s/\$$ext_params -d display_errors=0 -r/-d display_errors=0 -r/" $(SRC)/run-tests.php
	TEST_PHP_ARGS='-q' REPORT_EXIT_STATUS=1 make -C $(SRC) test
	lcov --base-directory ./$(SRC) --directory ./$(SRC) -c -o ./$(SRC)/COV.info --rc lcov_branch_coverage=1 
	lcov --remove $(SRC)/COV.info '/usr/*' --remove $(SRC)/COV.info '*tweetnacl.c' -o $(SRC)/COV.info --rc lcov_branch_coverage=1
	genhtml --show-details -o $(SRC)/COV.html ./$(SRC)/COV.info  --branch-coverage
endif

bench: joomla  ## run the benchmark

joomla:
	if [ ! -d "joomla-cms" ]; then \
		git clone --depth 1 https://github.com/joomla/joomla-cms.git >/dev/null; \
	fi
	cd joomla-cms; composer install >/dev/null 2>/dev/null
	echo "\nWith snuffleupagus:"
	cd joomla-cms; time php -d "extension=../$(SRC)/modules/snuffleupagus.so" -d "sp.configuration_file=../config/default.rules" libraries/vendor/phpunit/phpunit/phpunit --no-coverage >/dev/null
	echo "\nWithout snuffleupagus:"
	cd joomla-cms; time php libraries/vendor/phpunit/phpunit/phpunit --no-coverage >/dev/null

packages: debian  ## produce packages

debian:
	dpkg-buildpackage -i -us -uc -tc -I -rfakeroot

help:
	@awk -F ':|##' '/^[^\t].+?:.*?##/ { printf "\033[36m%-30s\033[0m %s\n", $$1, $$NF }' $(MAKEFILE_LIST) | sort

.PHONY: debian

=== debian/changelog ===
snuffleupagus (0.11.0) UNRELEASED; urgency=low
  [ jvoisin ]
  * Compatibility with PHP8.4                                                     
  * Fixed compilation on FreeBSD
  * Update the internal deprecation checks                                        

  [ cgzones ]
  * Print key and value on INI violations                                         
  * Improve `scripts/generate_rules.php` with regard to functions from global space prefixed with `\`
  * Add option to specify the allowed "php" wrapper types                         
  * Make 'phar' filenames work in `sp.disabled_functions`                         
  * Improve the documentation                                                     
  * Improve the default set of rules, especially with regard to portability       
  * Improve the Debian packaging                                                  
  * Improve behaviour when dealing with broken configuration file                 
  * Don't whitelist files if the function name is actually a method of a class in `scripts/generate_rules.php`
  * Ignore function definition in `scripts/generate_rules.php`                    
  * Improve configuration dumping                                                 

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Fri, 06 Sep 2024 14:30:00 +0200

snuffleupagus (0.10.0) UNRELEASED; urgency=low
  [ jvoisin ]
  * Compatibility with PHP8.3
  * Add `sp.log_max_len` to limit the maximum size of the log messages
  * Add an example configuration for Xenforo 2.2.12 
  * Url encode functions arguments when logging them

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Wed, 20 Sep 2023 15:25:00 +0200

snuffleupagus (0.9.0) UNRELEASED; urgency=low
  [ jvoisin ]
  * Compatibility with PHP8.2
  * Add the ability block object unserialization globally.

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Tue, 03 Jan 2023 20:25:00 +0200

snuffleupagus (0.8.3) UNRELEASED; urgency=low
  [ jvoisin ]
  * Mix the stacktrace in the sha256 for the filename of .dump()
  * Add the ability to dump the parameter passed to `eval`
  * Add the ability to match on `eval`'s parameter
  * Add optional extended checks for `readonly_exec`
  * Add config error for ini rules with identical key
  * Add disabled functions return type to config export
  * Make it actually possible to configure sloppy comparison on latests PHP7
  * Allow file:// prefix in include() with readonly_exec mode
  * Fix a possible crash when exporting function list
  * Fix a minor memory leak when parsing cookie-related configuration

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sat, 27 Aug 2022 17:30:00 +0200

snuffleupagus (0.8.2) UNRELEASED; urgency=low
  [ jvoisin ]
  * Fix compilation when ZTS is used
  * Fix a possible infinite loop

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sun, 20 Apr 2022 22:00:00 +0200

snuffleupagus (0.8.1) UNRELEASED; urgency=low
  [ jvoisin ]
  * Fix the version number
  * Fix a test on PHP7

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sun, 16 Apr 2022 19:45:00 +0200

snuffleupagus (0.8.0) UNRELEASED; urgency=low
  [ jvoisin ]
  * Compatibility with PHP8.1
  * Check for unsupported PHP version
  * Backport of Suhosin-ng patches:
    * Maximum stack depth/recursion limit
    * Maximum length for session id
    * $_SERVER strip/encode
    * Configuration dump
    * Support for conditional rules
    * INI settings protection
    * Output SP logs to stderr
    * Ported Suhosin rules to SP
  * Massive simplification of the configuration parser
  * Better memory management
  * Removal of internal calls to `call_user_func`
  * Increased portability of the default rules access different version of PHP
  * Start SP as late as possible, to hook as many things as possible
  * XML and Session support are now checked at runtime instead of at compile time

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sun, 15 Apr 2022 18:00:00 +0200

snuffleupagus (0.7.1) UNRELEASED; urgency=low
  [ jvoisin ]
  * Fixed possible memory-leaks when hooking via regular expressions               
  * Modernise the code by removing usage of `strtok`                               
  * Prevent a possible crash during configuration reloading                        
  * Fix the default rules to catch dangerous `chmod` calls                         
  * Improve compatibility with various `libpcre` configurations/versions           
  * Improve the default rules' compatibility with php8                             
  * Prevent XXE in php8 as well                                                    
  * Improve a bit the verbosity of the logs                                        
  * Add a rules file for php8  

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sun, 02 Aug 2021 19:29:00 +0200

snuffleupagus (0.7.0) UNRELEASED; urgency=medium
  [ jvoisin ]
  * PHP8 support
  * Stacktraces in dumps
  * The `>` operator skips over functions
  * PCRE2 is used when possible
  * The `generate_rules.php` script is now more portable
  * The strict mode is now disableable

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sun, 02 Jan 2021 19:22:00 +0100

snuffleupagus (0.6.0) UNRELEASED; urgency=medium

  [ jvoisin ]
  * More constification
  * Snuffleupagus should now be able to get client's ip addresses in more cases
  * Documented compatibility with Heroku
  * Improved logging
  * Added a couple of tests

  [ wargio ]
  * allow empty configurations

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Fri, 06 Nov 2020 17:45:00 +0200

snuffleupagus (0.5.1) UNRELEASED; urgency=medium

  [ jvoisin ]
  * Add support for syslog
  * Improve OSX support
  * Improve marginally of php8+ compatibility
  * Improve php7.4 compatibility
  * Improve the default ruleset
  * Improve the documentation
  * Improve the gitlab CI

 -- jvoisin <julien.voisin+snuffleupagus@dustri.org>  Sat, 20 Jun 2020 12:30:00 +0200

snuffleupagus (0.5.0) UNRELEASED; urgency=medium

  [ kkadosh ]


=== debian/control ===
Source: snuffleupagus
Priority: optional
Maintainer: Julien (jvoisin) Voisin <julien.voisin+snuffleupagus@dustri.org>
Build-Depends: debhelper-compat (= 12), dh-php, php-curl <!nocheck>, php-xml <!nocheck>, php7.0-dev | php7.1-dev | php7.2-dev | php7.3-dev | php7.4-dev | php8.0-dev | php8.1-dev | php8.2-dev | php8.3-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://snuffleupagus.readthedocs.io
Section: php
Vcs-Browser: https://github.com/jvoisin/snuffleupagus
Vcs-Git: https://github.com/jvoisin/snuffleupagus.git

Package: snuffleupagus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Security module for php7 and php8
 Snuffleupagus is a PHP 7+ and 8+ module designed to drastically raise the
 cost of attacks against websites, by killing entire bug classes. It also
 provides a powerful virtual-patching system, allowing administrator to fix
 specific vulnerabilities and audit suspicious behaviours without having to
 touch the PHP code.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory src --with php

execute_after_dh_auto_clean:
	cd ./src; phpize --clean

override_dh_auto_configure:
	cd ./src; phpize
	cd ./src; ./configure --enable-snuffleupagus

override_dh_auto_install:
	dh_testdir
	dh_testroot
	dh_installdirs
	mkdir -p debian/snuffleupagus/$$(/usr/bin/php-config --extension-dir)/
	mkdir -p debian/snuffleupagus/etc/php/$$(/usr/bin/php-config --version | cut -d '.' -f1-2)/mods-available/
	install -m 644 src/modules/snuffleupagus.so debian/snuffleupagus/$$(/usr/bin/php-config --extension-dir)/snuffleupagus.so
	install -m 644 config/snuffleupagus.ini debian/snuffleupagus/etc/php/$$(/usr/bin/php-config --version | cut -d '.' -f1-2)/mods-available/snuffleupagus.ini

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	sed -i "s/\$$ext_params -d display_errors=0 -r/-d display_errors=0 -r/" src/run-tests.php
	TEST_PHP_ARGS="-q" REPORT_EXIST_STATUS=1 make -C src test
else
	echo "skip tests"
endif
